

local settings = --Settings
{
	--Shop menu settings
	menuTitle = "Shop", --Title of menu
	menuPageNext = "Next page", --Text of next page button
	menuPagePrev = "Previous page", --Text of previous page button
	
	--Chat command settings
	commandShop = "skins", --Chat command to open shop (dont include "!")
	commandHelp = "shophelp", --Chat command to see shop help? (dont include "!")
	helpColor = "000200000", --Color the help text got
	hideCommands = 0, --Hide chat commands? (1 = yes, 0 = no)
	
	--Point settings
	startPoints = 0, --Amount of points each player got at start
	killPoints = 0, --Amount per kill, the amount will be a random one between the 2 numbers
	freePointsTime = 0, --How many secs between each player get free points
	freePointsAmount = 0, --The amount of money they get each time
	
	--HUD settings
	pointId = 10, --The id of this hud text, if it dont shop up in server you may need to change it
	pointColor = "200200000", --Color the point text got
	pointPos = {10, 200}, --The x and y position of the text
	
	--No money settings
	noMoneyText = "You dont have enough points!", --Text it will say if the player dont have enough money
	noMoneyColor = 255000000 --Color of text for no money
}



local commands = {}

function ChatCommands(id, msg) --My chat command system
	local cmd = string.lower(msg)
	
	if commands[cmd] then
		commands[cmd](id)
		
		return settings.hideCommands
	end
end
addhook("say", "ChatCommands")

local function AddCommand(cmd, OnSay) --Used to add a chat command
	commands["@"..string.lower(cmd)] = OnSay
end

AddCommand(settings.commandHelp, function(id) --Chat command to display help
	parse('msg2 '..id..' "'..settings.helpColor.."-----------------------Shop help-----------------------")
	parse('msg2 '..id..' "'..settings.helpColor.."Kill enemies to get points (you will get "..settings.killPoints.." points")
	parse('msg2 '..id..' "'..settings.helpColor.."Type "..settings.commandShop.." to open the shop")
	parse('msg2 '..id..' "'..settings.helpColor.."Type "..settings.commandHelp.." to see this")
	parse('msg2 '..id..' "'..settings.helpColor.."--------------------------------------------------------")
end)



local playerData = {} --Table containing all player info

local function SetPoints(id, points) --Used to set point of a player
	if player(id, "bot") == false then
		playerData[id].points = points
		
		parse('hudtxt2 '..id..' '..settings.pointId..' "'..settings.pointColor..settings.pointText..playerData[id].points..'" '..settings.pointPos[1]..' '..settings.pointPos[2])
	end
end


function SetupPlayer(id) --setup player info
	if player(id, "bot") == false then
		playerData[id] = {}
		playerData[id].page = 1
		
		SetPoints(id, settings.startPoints)
	end
end
addhook("join", "SetupPlayer")

function AddPointsWhenKill(killer, victim, weapon, x, y) --When a player kills another player he will get points
	if player(killer, "bot") == false then
		SetPoints(killer, playerData[killer].points+settings.killPoints)
	end
end
addhook("kill", "AddPointsWhenKill")


local items = {} --Table containing all item info

local function AddItem(name, price, OnBuy) --Used to add a item to the shop
	table.insert(items, {name = name, price =price, OnBuy = OnBuy})
end

local function AddItemWeapon(weapon, price) --Used to add a weapon to the shop
	AddItem(itemtype(weapon, "name"), price, function(id)
		parse('equip '..id..' '..weapon)
		parse('setweapon '..id..' '..weapon)
	end)
end


--Add items here----------------------------------------------------------------------------------------------------------------------

--Page 1
AddItem("Skin1.WhiteForest", 0, function(id)
	local headcrab = image("gfx/npc/Skin1.bmp<m>", 1, 0, 200+id)
end)

AddItem("Skin2.PhoenixConnexion", 0, function(id)
	local headcrab = image("gfx/npc/Skin2.bmp<m>", 1, 0, 200+id)
end)

AddItem("Skin3.RusCT", 0, function(id)
	local headcrab = image("gfx/npc/Skin3.bmp<m>", 1, 0, 200+id)
end)

AddItem("Skin4.Gign", 0, function(id)
	local headcrab = image("gfx/npc/Skin4.bmp<m>", 1, 0, 200+id)
end)

AddItem("Skin5.TEK", 0, function(id)
	local headcrab = image("gfx/npc/Skin5.bmp<m>", 1, 0, 200+id)
end)

AddItem("Skin6.SwBlack", 0, function(id)
	local headcrab = image("gfx/npc/Skin6.bmp<m>", 1, 0, 200+id)
end)

AddItem("Skin7.SwWhite", 0, function(id)
	local headcrab = image("gfx/npc/Skin7.bmp<m>", 1, 0, 200+id)
end)

AddItem("Skin8.Vanno", 0, function(id)
	local headcrab = image("gfx/npc/Skin8.bmp<m>", 1, 0, 200+id)
end)

AddItem("Skin9.DesertTerror", 0, function(id)
	local headcrab = image("gfx/npc/Skin9.bmp<m>", 1, 0, 200+id)
end)

AddItem("Skin10.Pirate", 0, function(id)
	local headcrab = image("gfx/npc/Skin10.bmp<m>", 1, 0, 200+id)
end)

AddItem("Skin11.Anarchist", 0, function(id)
	local headcrab = image("gfx/npc/Skin11.bmp<m>", 1, 0, 200+id)
end)

AddItem("Skin12.FBI", 0, function(id)
	local headcrab = image("gfx/npc/Skin12.bmp<m>", 1, 0, 200+id)
end)
--------------------------------------------------------------------------------------------------------------------------------------



local page = 1
local pages = {}
pages[page] = {}

local pageCheck = 0

for k, v in pairs(items) do --Here I am settings up the pages table so I can easly add items without worring about space in the menu
	pageCheck = pageCheck+1
	
	if pageCheck == 7 then
		page = page+1
		pages[page] = {}
		
		pageCheck = 1
	end
	
	table.insert(pages[page], k) --Insert the item index into the page
end

local function GenerateButtonString(item) --I made this so I dont have to type as much over and over
	if item then --If item is valid
		return item.name.."|"..item.price --Return the button text
	else
		return "" --Return no button
	end
end

local function OpenShopMenu(id) --Used to open the shop
	local indexes = pages[playerData[id].page] --Gets a table of the indexes for this page
	
	menu(id, settings.menuTitle..","..GenerateButtonString(items[indexes[1]])..","..GenerateButtonString(items[indexes[2]])..","..GenerateButtonString(items[indexes[3]])..","..GenerateButtonString(items[indexes[4]])..","..GenerateButtonString(items[indexes[5]])..","..GenerateButtonString(items[indexes[6]])..",,"..(pages[playerData[id].page+1] and settings.menuPageNext or "")..","..(pages[playerData[id].page-1] and settings.menuPagePrev or ""))
end
AddCommand(settings.commandShop, OpenShopMenu)

function ShopMenuHook(id, title, button)
	if title == settings.menuTitle then --If its my shop menu
		local index = pages[playerData[id].page][button] --Index of item
		local price = items[index] and items[index].price or nil --Price of item
		
		if button <= 6 then --If one of the 6 buttons is the one pressed then
			if playerData[id].points >= price then --If the players money is more than the price then
				items[index].OnBuy(id) --Do what the items gives
				SetPoints(id, playerData[id].points-price) --Take the players money
			else
				msg2(id, ""..settings.noMoneyColor..settings.noMoneyText) --Message if the player dont have enough money
			end
		end
		
		if button == 8 then --If button is the "Next page" button
			playerData[id].page = playerData[id].page+1 --Increment the page number for that player
			OpenShopMenu(id) --And open the menu agian with the new page
		elseif button == 9 then --If button is the "Prev page" button
			playerData[id].page = playerData[id].page-1 --Decrement the page number for that player
			OpenShopMenu(id) --And open the menu agian with the new page
		end
		
	end
end
addhook("menu", "ShopMenuHook")

function AddPointsTimer() --Used to give all players some free points
	local playerList = player(0, "table") --Get all players in a table
	
	for k, v in pairs(playerList) do
		if player(v, "bot") == false then
			SetPoints(v, playerData[v].points+settings.freePointsAmount) --Give all existing players some points
		end
	end
end
timer(settings.freePointsTime*1000, "AddPointsTimer", "", 0) --Infinite timer
